Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class TimeValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.CalendarValue
                  net.sf.saxon.value.TimeValue

All Implemented Interfaces:
  Serializable, Comparable, SequenceIterable, Item, ValueRepresentation

    public final class TimeValue

extends CalendarValue

A value of type xs:time

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.value.CalendarValue
`NO_TIMEZONE`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`TimeValue(byte hour, byte minute, byte second, int microsecond, int tz)` Construct a time value given the hour, minute, second, and microsecond components.
`TimeValue(CharSequence s)` Constructor: create a dateTime value from a supplied string, in ISO 8601 format
`TimeValue(GregorianCalendar calendar, int tz)` Constructor: create a time value given a Java calendar object

Method Summary
`CalendarValue` | `add(DurationValue duration)` Add a duration to a dateTime
`CalendarValue` | `adjustTimezone(int timezone)` Return a new time with the same normalized value, but in a different timezone.
`int` | `compareTo(CalendarValue other, Configuration config)` Compare the value to another dateTime value
`int` | `compareTo(Object other)` Compare the value to another dateTime value
`AtomicValue` | `convertPrimitive(BuiltInAtomicType requiredType, boolean validate, XPathContext context)` Convert to target data type
`Object` | `convertToJava(Class target, XPathContext context)` Convert to Java object (for passing to external functions)
`AtomicValue` | `copy(AtomicType typeLabel)` Make a copy of this date, time, or dateTime value
`boolean` | `equals(Object other)` Compare two (sequence) values for equality.
`GregorianCalendar` | `getCalendar()` Get a Java Calendar object corresponding to this time, on a reference date
`ComparisonKey` | `getComparisonKey(Configuration config)` Get a comparison key for this value.
`AtomicValue` | `getComponent(int component)` Get a component of the value.
`byte` | `getHour()` Get the hour component, 0-23
`int` | `getMicrosecond()` Get the microsecond component, 0-999999
`byte` | `getMinute()` Get the minute component, 0-59
`BuiltInAtomicType` | `getPrimitiveType()` Determine the primitive type of the value.
`byte` | `getSecond()` Get the second component, 0-59
`CharSequence` | `getStringValueCS()` Convert to string
`Comparable` | `getXPathComparable()` Get a Comparable value that implements the XPath ordering comparison semantics for this value.
`int` | `hashCode()` Return a hash code to support the equals() function
`DayTimeDurationValue` | `subtract(CalendarValue other, XPathContext context)` Determine the difference between two points in time, as a duration
`DateTimeValue` | `toDateTime()` Convert to a DateTime value.

Methods inherited from class net.sf.saxon.value.CalendarValue
`adjustTimezone, appendTimezone, appendTimezone, getStringValue, getTimezoneInMinutes, hasTimezone, removeTimezone, setTimezoneInMinutes`

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, effectiveBooleanValue, getCardinality, getItemType, getLength, getTypedValue, getTypeLabel, hasBuiltInType, isMultiValued, itemAt, iterate, process, setTypeLabel, toString`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convert, convertJavaObjectToXPath, fromItem, getCanonicalLexicalRepresentation, getIterator, getSchemaComparable, iterate, makeQNameValue, reduce, stringToNumber`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### TimeValue

    public TimeValue(byte hour,
                     byte minute,
                     byte second,
                     int microsecond,
                     int tz)

  Construct a time value given the hour, minute, second, and microsecond components. This constructor performs no validation.

  Parameters:
    `hour` - the hour value, 0-23
    `minute` - the minutes value, 0-59
    `second` - the seconds value, 0-59
    `microsecond` - the number of microseconds, 0-999999
    `tz` - the timezone displacement in minutes from UTC. Supply the value `CalendarValue.NO_TIMEZONE` if there is no timezone component.

### TimeValue

    public TimeValue(GregorianCalendar calendar,
                     int tz)

  Constructor: create a time value given a Java calendar object

  Parameters:
    `calendar` - holds the date and time
    `tz` - the timezone offset in minutes, or NO_TIMEZONE indicating that there is no timezone

### TimeValue

    public TimeValue(CharSequence s)
              throws XPathException

  Constructor: create a dateTime value from a supplied string, in ISO 8601 format

  Throws:
    `XPathException`

Method Detail

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Specified by:
    `getPrimitiveType` in class `AtomicValue`

### getHour

    public byte getHour()

  Get the hour component, 0-23

### getMinute

    public byte getMinute()

  Get the minute component, 0-59

### getSecond

    public byte getSecond()

  Get the second component, 0-59

### getMicrosecond

    public int getMicrosecond()

  Get the microsecond component, 0-999999

### convertPrimitive

    public AtomicValue convertPrimitive(BuiltInAtomicType requiredType,
                                        boolean validate,
                                        XPathContext context)

  Convert to target data type

  Specified by:
    `convertPrimitive` in class `AtomicValue`
  Parameters:
    `requiredType` - an integer identifying the required atomic type
    `context` -
    `validate` - true if validation is required. If set to false, the caller guarantees that the value is valid for the target data type, and that further validation is therefore not required. Note that a validation failure may be reported even if validation was not requested.
  Returns:
    an AtomicValue, a value of the required type; or an ErrorValue

### getStringValueCS

    public CharSequence getStringValueCS()

  Convert to string

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Overrides:
    `getStringValueCS` in class `AtomicValue`
  Returns:
    ISO 8601 representation, in the localized timezone (the timezone held within the value).
  See Also:
    `Item.getStringValue()`

### toDateTime

    public DateTimeValue toDateTime()

  Convert to a DateTime value. The date components represent a reference date, as defined in the spec for comparing times.

  Specified by:
    `toDateTime` in class `CalendarValue`

### getCalendar

    public GregorianCalendar getCalendar()

  Get a Java Calendar object corresponding to this time, on a reference date

  Specified by:
    `getCalendar` in class `CalendarValue`
  Returns:
    A Calendar object representing the date and time. Note that Java can only represent the time to millisecond precision, and that it does not support the full range of timezones required by XPath (-14:00 to +14:00)

### copy

    public AtomicValue copy(AtomicType typeLabel)

  Make a copy of this date, time, or dateTime value

  Specified by:
    `copy` in class `AtomicValue`
  Parameters:
    `typeLabel` -

### adjustTimezone

    public CalendarValue adjustTimezone(int timezone)

  Return a new time with the same normalized value, but in a different timezone. This is called only for a TimeValue that has an explicit timezone

  Specified by:
    `adjustTimezone` in class `CalendarValue`
  Parameters:
    `timezone` - the new timezone offset, in minutes
  Returns:
    the time in the new timezone. This will be a new TimeValue unless no change was required to the original value

### convertToJava

    public Object convertToJava(Class target,
                                XPathContext context)
                         throws XPathException

  Convert to Java object (for passing to external functions)

  Overrides:
    `convertToJava` in class `Value`
  Throws:
    `XPathException`

### getComponent

    public AtomicValue getComponent(int component)
                             throws XPathException

  Get a component of the value. Returns null if the timezone component is requested and is not present.

  Overrides:
    `getComponent` in class `AtomicValue`
  Throws:
    `XPathException`

### getXPathComparable

    public Comparable getXPathComparable()

  Get a Comparable value that implements the XPath ordering comparison semantics for this value. Returns null if the value is not comparable according to XPath rules. The default implementation returns null. This is overridden for types that allow ordered comparisons in XPath: numeric, boolean, string, date, time, dateTime, yearMonthDuration, dayTimeDuration, and anyURI.

  Overrides:
    `getXPathComparable` in class `AtomicValue`

### compareTo

    public int compareTo(Object other)

  Compare the value to another dateTime value

  Specified by:
    `compareTo` in interface `Comparable`
  Overrides:
    `compareTo` in class `Value`
  Parameters:
    `other` - The other dateTime value
  Returns:
    negative value if this one is the earler, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
  Throws:
    `ClassCastException` - if the other value is not a DateTimeValue (the parameter is declared as Object to satisfy the Comparable interface)

### compareTo

    public int compareTo(CalendarValue other,
                         Configuration config)

  Compare the value to another dateTime value

  Specified by:
    `compareTo` in class `CalendarValue`
  Parameters:
    `other` - The other dateTime value
  Returns:
    negative value if this one is the earler, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
  Throws:
    `ClassCastException` - if the other value is not a DateTimeValue (the parameter is declared as Object to satisfy the Comparable interface)

### getComparisonKey

    public ComparisonKey getComparisonKey(Configuration config)

  Get a comparison key for this value. Two values are equal if and only if they their comparison keys are equal

  Specified by:
    `getComparisonKey` in class `CalendarValue`

### equals

    public boolean equals(Object other)

  Description copied from class: `Value`
  Compare two (sequence) values for equality. This supports identity constraints in XML Schema, which allow list-valued elements and attributes to participate in key and uniqueness constraints. This method returns false if any error occurs during the comparison, or if any of the items in either sequence is a node rather than an atomic value.

  Overrides:
    `equals` in class `Value`

### hashCode

    public int hashCode()

  Description copied from class: `Value`
  Return a hash code to support the equals() function

  Overrides:
    `hashCode` in class `Value`

### add

    public CalendarValue add(DurationValue duration)
                      throws XPathException

  Add a duration to a dateTime

  Specified by:
    `add` in class `CalendarValue`
  Parameters:
    `duration` - the duration to be added (may be negative)
  Returns:
    the new date
  Throws:
    `XPathException` - if the duration is an xs:duration, as distinct from a subclass thereof

### subtract

    public DayTimeDurationValue subtract(CalendarValue other,
                                         XPathContext context)
                                  throws XPathException

  Determine the difference between two points in time, as a duration

  Overrides:
    `subtract` in class `CalendarValue`
  Parameters:
    `other` - the other point in time
    `context` -
  Returns:
    the duration as an xs:dayTimeDuration
  Throws:
    `XPathException` - for example if one value is a date and the other is a time

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.